/*
  GPS .  RA3PCS
----------------------------------------------------------------------
 WriteNibble -    
 WriteByteCommand -    
 WriteByte -     
 GoToSymbol -       
 ClearLCD -  
 ShowChar -    
 ShowStr -    
 InitLCD -  
----------------------------------------------------------------------
     B,
   D.
      LCD
    !!!
----------------------------------------------------------------------
*/


#include <16F877.h>
#device ADC=8   // 8   
#use delay(clock=20000000)
#fuses HS, WDT=10 //  HIGH SPEED   . = 10 (   3 )
#use rs232(baud=4800, parity=N, xmit=PIN_C6, rcv=PIN_C7, stream=OUT_STREAM) // RS232
#byte ADCON0 = 0x1F //  a  


/*     LCD*/
#define RD_0 output_bit(PIN_B2,0)
#define RD_1 output_bit(PIN_B2,1)
#define RS_0 output_bit(PIN_B1,0)
#define RS_1 output_bit(PIN_B1,1)
#define E_0 output_bit(PIN_B0,0)
#define E_1 output_bit(PIN_B0,1)
#define COM_ON output_bit (PIN_C4,1) //      = 1
#define COM_OFF output_bit (PIN_C4,0) //      = 0

/*    */
char i;//     
char menu_number;// = 0x03; //  
char str3[21] = {'*',' ','K','o',0xbd,0xe4,0xb8,0xb4,'y','p',0xb8,'p','o',0xb3,'a',0xbd,0xb8,'e',' ','*'}; //    
char str4[21] = {'*',' ',' ',' ',' ','y','c',0xbf,'p','o',0xb9,'c',0xbf,0xb3,'a',' ',' ',' ',' ','*'};
char start[21] = {'*',' ',' ','B',0xc3,0xb2,'e','p',0xb8,0xbf,'e',' ','p','e',0xb6,0xb8,0xbc,' ',' ','*'};
char lowvolt[21] = {'*',' ',0xa4,'a','p',0xc7,0xe3,0xb8,0xbf,'e',' ',0xb2,'a',0xbf,'a','p','e',0xc6,' ','*'};
char lowvolt2[21] = "  * LOW  VOLTAGE *  ";
char highvolt[21] = {'*',' ',0xa0,'a',0xbf,'a','p','e',0xc7,' ',0xb7,'a','p',0xc7,0xb6,'e',0xbd,'a',' ','*'};
char emptystr[21] = "                    ";
char s1; //  .    '$'
char s4; //   
char s5; //   
char s6; //   
char buf[75]; //    
char adc_value; //     
char volt;//   
char volt_1;	//    
char volt_2;	//    
char volt_3;    //    
char volts[11] ={'H','a',0xbe,'p',0xc7,0xb6,'e',0xbd,0xb8,'e',':'};

unsigned char LCD_Address;
 
//   -  
void WriteNibble(unsigned char data)
{
  RD_0;
  RS_0;
  E_0;
//  delay_ms(1); //      !
  output_D(data & 0x0F); //   
  delay_ms(1);
  E_1;
//  delay_ms(1);
  E_0;
//  delay_ms(1);
}

//      
void WriteByteCommand(unsigned char data)
{
  output_D(0x00 >> 4);// 	
  RD_0;
  RS_0;
  E_0;
  delay_ms(1);
  output_D(data >> 4);
  delay_ms(1);
  E_1;
//  delay_ms(1);
  E_0;
//  delay_ms(1);
  output_D(data & 0xF);
//  delay_ms(1);
  E_1;
//  delay_ms(1);
  E_0;
  RD_0;
//  delay_ms(1);
}
//      
void WriteByte(unsigned char data)
{	
  
  RD_0;
  RS_1;//     
  E_0;
//  delay_ms(1);
  output_D(data >> 4);
//  delay_ms(1);
  E_1;
//  delay_ms(1);
  E_0;
//  delay_ms(1);
  output_D(data & 0xF);
//  delay_ms(1);
  E_1;
//  delay_ms(1);
  E_0;
  RS_0;
  RD_0;
//  delay_ms(1);
}

//        SymbNum
void GoToSymbol(char SymbNum)
{
 char curs = 0x80; 
 LCD_Address = curs+SymbNum;
 WriteByteCommand(LCD_Address);
 delay_us(50);
 }

//  
void ClearLCD(void)
{
  WriteByteCommand(0x01);
  delay_ms(100);
}


//    
void ShowChar(unsigned char c)
{
  WriteByte(c);
  delay_us(50);
}


//    
void ShowStr(unsigned char *s)
{
  while (*s != 0) ShowChar(*s++);
  delay_ms (1);
}


void InitLCD(void) //  
{
  
  delay_ms(50);
  WriteNibble(0x03); //
  WriteNibble(0x03);
  WriteNibble(0x03);
  WriteNibble(0x02); //   
  WriteByteCommand(0x28); // 
  WriteByteCommand(0x08); // 
  WriteByteCommand(0x01); // 
  WriteByteCommand(0x06); // 
  WriteByteCommand(0x0C); // ,  
}  

/****************************************************************************/
/****************   GPS  *********************/

void GLL_config() //  GPS   GLL 
{
	putc (0x25);
	putc (0x25);
	putc (0xf1);
	putc (0x04);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x01);
	putc (0x00);
	putc (0xf4);
	putc (0x0d);
	putc (0x0a);
}

void GGA_config() //  GPS   GGA 
{
	putc (0x25);
	putc (0x25);
	putc (0xf1);
	putc (0x04);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x01);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0xf4);
	putc (0x0d);
	putc (0x0a);
}

void ZDA_config() //  GPS   ZDA 
{
	putc (0x25);
	putc (0x25);
	putc (0xf1);
	putc (0x04);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x01);
	putc (0xf4);
	putc (0x0d);
	putc (0x0a);
}

void VTG_config() //  GPS   VTG 
{
	putc (0x25);
	putc (0x25);
	putc (0xf1);
	putc (0x04);
	putc (0x00);
	putc (0x00);
	putc (0x01);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0x00);
	putc (0xf4);
	putc (0x0d);
	putc (0x0a);
}

void PC_config() //  GPS     
{
	putc (0x25);
	putc (0x25);
	putc (0xf1);
	putc (0x04);
	putc (0x01);
	putc (0x01);
	putc (0x00);
	putc (0x01);
	putc (0x01);
	putc (0x01);
	putc (0x00);
	putc (0x00);
	putc (0xf4);
	putc (0x0d);
	putc (0x0a);
}



/**********************************************************************************************/
/*********************    ***********************/

void Voltage_displ() //         ASCII
{
	if (adc_value == 0x8C)   
		{
		volt ='5';
		volt_1 ='9';
		volt_2 ='5';
		volt_3 = '7';
		}
	if (adc_value == 0x8D)   
		{
		volt ='6';
		volt_1 ='0';
		volt_2 ='0';
		volt_3 = '0';
		}
	if (adc_value == 0x8E)   
		{
		volt ='6';
		volt_1 ='0';
		volt_2 ='4';
		volt_3 = '2';
		}
	if (adc_value == 0x8F)   
		{
		volt ='6';
		volt_1 ='0';
		volt_2 ='8';
		volt_3 = '5';
		}
	if (adc_value == 0x90)   
		{
		volt ='6';
		volt_1 ='1';
		volt_2 ='2';
		volt_3 = '8';
		}	
	if (adc_value == 0x91)   
		{
		volt ='6';
		volt_1 ='1';
		volt_2 ='7';
		volt_3 = '1';
		}					
	if (adc_value == 0x92)   
		{
		volt ='6';
		volt_1 ='2';
		volt_2 ='1';
		volt_3 = '4';
		}
	if (adc_value == 0x93)   
		{
		volt ='6';
		volt_1 ='2';
		volt_2 ='5';
		volt_3 = '7';
		}
	if (adc_value == 0x94)   
		{
		volt ='6';
		volt_1 ='3';
		volt_2 ='0';
		volt_3 = '0';
		}				
	if (adc_value == 0x95)   
		{
		volt ='6';
		volt_1 ='3';
		volt_2 ='4';
		volt_3 = '3';
		}
	if (adc_value == 0x96)   
		{
		volt ='6';
		volt_1 ='3';
		volt_2 ='8';
		volt_3 = '6';
		}
	if (adc_value == 0x97)   
		{
		volt ='6';
		volt_1 ='4';
		volt_2 ='2';
		volt_3 = '9';
		}
	if (adc_value == 0x98)   
		{
		volt ='6';
		volt_1 ='4';
		volt_2 ='7';
		volt_3 = '2';
		}
	if (adc_value == 0x99)   
		{
		volt ='6';
		volt_1 ='5';
		volt_2 ='1';
		volt_3 = '4';
		}
	if (adc_value == 0x9A)   
		{
		volt ='6';
		volt_1 ='5';
		volt_2 ='5';
		volt_3 = '7';
		}
	if (adc_value == 0x9B)   
		{
		volt ='6';
		volt_1 ='6';
		volt_2 ='0';
		volt_3 = '0';
		}
	if (adc_value == 0x9C)   
		{
		volt ='6';
		volt_1 ='6';
		volt_2 ='4';
		volt_3 = '3';
		}
	if (adc_value == 0x9D)   
		{
		volt ='6';
		volt_1 ='6';
		volt_2 ='8';
		volt_3 = '6';
		}
	if (adc_value == 0x9E)   
		{
		volt ='6';
		volt_1 ='7';
		volt_2 ='2';
		volt_3 = '9';
		}
	if (adc_value == 0x9F)   
		{
		volt ='6';
		volt_1 ='7';
		volt_2 ='7';
		volt_3 = '2';
		}
	if (adc_value == 0xA0)   
		{
		volt ='6';
		volt_1 ='8';
		volt_2 ='1';
		volt_3 = '5';
		}
	if (adc_value == 0xA1)   
		{
		volt ='6';
		volt_1 ='8';
		volt_2 ='5';
		volt_3 = '8';
		}
	if (adc_value == 0xA2)   
		{
		volt ='6';
		volt_1 ='9';
		volt_2 ='0';
		volt_3 = '1';
		}
	if (adc_value == 0xA3)   
		{
		volt ='6';
		volt_1 ='9';
		volt_2 ='4';
		volt_3 = '4';
		}
	if (adc_value == 0xA4)   
		{
		volt ='6';
		volt_1 ='9';
		volt_2 ='8';
		volt_3 = '6';
		}
	if (adc_value == 0xA5)   
		{
		volt ='7';
		volt_1 ='0';
		volt_2 ='2';
		volt_3 = '9';
		}
	if (adc_value == 0xA6)   
		{
		volt ='7';
		volt_1 ='0';
		volt_2 ='7';
		volt_3 = '2';
		}
	if (adc_value == 0xA7)   
		{
		volt ='7';
		volt_1 ='1';
		volt_2 ='1';
		volt_3 = '5';
		}
	if (adc_value == 0xA8)   
		{
		volt ='7';
		volt_1 ='1';
		volt_2 ='5';
		volt_3 = '8';
		}
	if (adc_value == 0xA9)   
		{
		volt ='7';
		volt_1 ='2';
		volt_2 ='0';
		volt_3 = '1';
		}
	if (adc_value == 0xAA)   
		{
		volt ='7';
		volt_1 ='2';
		volt_2 ='4';
		volt_3 = '4';
		}
	if (adc_value == 0xAB)   
		{
		volt ='7';
		volt_1 ='2';
		volt_2 ='8';
		volt_3 = '7';
		}
	if (adc_value == 0xAC)   
		{
		volt ='7';
		volt_1 ='3';
		volt_2 ='3';
		volt_3 = '0';
		}
	if (adc_value == 0xAD)   
		{
		volt ='7';
		volt_1 ='3';
		volt_2 ='7';
		volt_3 = '3';
		}
	if (adc_value == 0xAE)   
		{
		volt ='7';
		volt_1 ='4';
		volt_2 ='1';
		volt_3 = '6';
		}
	if (adc_value == 0xAF)   
		{
		volt ='7';
		volt_1 ='4';
		volt_2 ='5';
		volt_3 = '8';
		}
	if (adc_value == 0xB0)   
		{
		volt ='7';
		volt_1 ='5';
		volt_2 ='0';
		volt_3 = '1';
		}
	if (adc_value == 0xB1)   
		{
		volt ='7';
		volt_1 ='5';
		volt_2 ='4';
		volt_3 = '4';
		}
	if (adc_value == 0xB2)   
		{
		volt ='7';
		volt_1 ='5';
		volt_2 ='8';
		volt_3 = '7';
		}
	if (adc_value == 0xB3)   
		{
		volt ='7';
		volt_1 ='6';
		volt_2 ='3';
		volt_3 = '0';
		}
	if (adc_value == 0xB4)   
		{
		volt ='7';
		volt_1 ='6';
		volt_2 ='7';
		volt_3 = '3';
		}
	if (adc_value == 0xB5)   
		{
		volt ='7';
		volt_1 ='7';
		volt_2 ='1';
		volt_3 = '6';
		}
	if (adc_value == 0xB6)   
		{
		volt ='7';
		volt_1 ='7';
		volt_2 ='5';
		volt_3 = '9';
		}
	if (adc_value == 0xB7)   
		{
		volt ='7';
		volt_1 ='8';
		volt_2 ='0';
		volt_3 = '2';
		}
	if (adc_value == 0xB8)   
		{
		volt ='7';
		volt_1 ='8';
		volt_2 ='4';
		volt_3 = '5';
		}
	if (adc_value == 0xB9)   
		{
		volt ='7';
		volt_1 ='8';
		volt_2 ='8';
		volt_3 = '8';
		}
	if (adc_value == 0xBA)   
		{
		volt ='7';
		volt_1 ='9';
		volt_2 ='3';
		volt_3 = '0';
		}
	if (adc_value == 0xBB)   
		{
		volt ='7';
		volt_1 ='9';
		volt_2 ='7';
		volt_3 = '3';
		}
	if (adc_value == 0xBC)   
		{
		volt ='8';
		volt_1 ='0';
		volt_2 ='1';
		volt_3 = '6';
		}
	if (adc_value == 0xBD)   
		{
		volt ='8';
		volt_1 ='0';
		volt_2 ='5';
		volt_3 = '9';
		}
	if (adc_value == 0xBE)   
		{
		volt ='8';
		volt_1 ='1';
		volt_2 ='0';
		volt_3 = '2';
		}
	if (adc_value == 0xBF)   
		{
		volt ='8';
		volt_1 ='1';
		volt_2 ='4';
		volt_3 = '5';
		}
	if (adc_value == 0xC0)   
		{
		volt ='8';
		volt_1 ='1';
		volt_2 ='8';
		volt_3 = '8';
		}
	if (adc_value == 0xC1)   
		{
		volt ='8';
		volt_1 ='2';
		volt_2 ='3';
		volt_3 = '1';
		}
	if (adc_value == 0xC2)   
		{
		volt ='8';
		volt_1 ='2';
		volt_2 ='7';
		volt_3 = '4';
		}
	if (adc_value == 0xC3)   
		{
		volt ='8';
		volt_1 ='3';
		volt_2 ='1';
		volt_3 = '7';
		}
	if (adc_value == 0xC4)   
		{
		volt ='8';
		volt_1 ='3';
		volt_2 ='6';
		volt_3 = '0';
		}
	if (adc_value == 0xC5)   
		{
		volt ='8';
		volt_1 ='4';
		volt_2 ='0';
		volt_3 = '2';
		}
	if (adc_value == 0xC6)   
		{
		volt ='8';
		volt_1 ='4';
		volt_2 ='4';
		volt_3 = '5';
		}
	if (adc_value == 0xC7)   
		{
		volt ='8';
		volt_1 ='4';
		volt_2 ='8';
		volt_3 = '8';
		}
	if (adc_value == 0xC8)   
		{
		volt ='8';
		volt_1 ='5';
		volt_2 ='3';
		volt_3 = '1';
		}
	if (adc_value == 0xC9)   
		{
		volt ='8';
		volt_1 ='5';
		volt_2 ='7';
		volt_3 = '4';
		}
	if (adc_value == 0xCA)   
		{
		volt ='8';
		volt_1 ='6';
		volt_2 ='1';
		volt_3 = '7';
		}
	if (adc_value == 0xCB)   
		{
		volt ='8';
		volt_1 ='6';
		volt_2 ='6';
		volt_3 = '0';
		}
	if (adc_value == 0xCC)   
		{
		volt ='8';
		volt_1 ='7';
		volt_2 ='0';
		volt_3 = '3';
		}
	if (adc_value == 0xCD)   
		{
		volt ='8';
		volt_1 ='7';
		volt_2 ='4';
		volt_3 = '6';
		}
	if (adc_value == 0xCE)   
		{
		volt ='8';
		volt_1 ='7';
		volt_2 ='8';
		volt_3 = '9';
		}
	if (adc_value == 0xCF)   
		{
		volt ='8';
		volt_1 ='8';
		volt_2 ='3';
		volt_3 = '2';
		}
	if (adc_value == 0xD0)   
		{
		volt ='8';
		volt_1 ='8';
		volt_2 ='7';
		volt_3 = '5';
		}
	if (adc_value == 0xD1)   
		{
		volt ='8';
		volt_1 ='9';
		volt_2 ='1';
		volt_3 = '8';
		}
	if (adc_value == 0xD2)   
		{
		volt ='8';
		volt_1 ='9';
		volt_2 ='6';
		volt_3 = '1';
		}
	if (adc_value == 0xD3)   
		{
		volt ='9';
		volt_1 ='0';
		volt_2 ='0';
		volt_3 = '4';
		}
	if (adc_value == 0xD4)   
		{
		volt ='9';
		volt_1 ='0';
		volt_2 ='4';
		volt_3 = '7';
		}
	if (adc_value == 0xD5)   
		{
		volt ='9';
		volt_1 ='0';
		volt_2 ='9';
		volt_3 = '0';
		}
	if (adc_value == 0xD6)   
		{
		volt ='9';
		volt_1 ='1';
		volt_2 ='3';
		volt_3 = '3';
		}
	if (adc_value == 0xD7)   
		{
		volt ='9';
		volt_1 ='1';
		volt_2 ='7';
		volt_3 = '6';
		}
	if (adc_value == 0xD8)   
		{
		volt ='9';
		volt_1 ='2';
		volt_2 ='1';
		volt_3 = '9';
		}
/*	if (adc_value == 0xFD)   
		{
		volt ='9';
		volt_1 ='6';
		volt_2 ='7';
		volt_3 = '2';
		}
	if (adc_value == 0xFE)   
		{
		volt ='9';
		volt_1 ='7';
		volt_2 ='0';
		volt_3 = '9';
		}
	if (adc_value == 0xFF)   
		{
		volt ='9';
		volt_1 ='7';
		volt_2 ='4';
		volt_3 = '6';      
		}                */
}

void Config_message() //     
	{
	GoToSymbol (0x00);
	Showstr (str3);
	GoToSymbol(0x40);
	Showstr (str4);
	Showstr (emptystr);
	GoToSymbol (0x14);
	Showstr (emptystr);
	}

void Beep() //  
{
	i = 0;
	while (i < 150)
		{
		output_bit(PIN_C1,1);
		delay_us(100);
		output_bit(PIN_C1,0);
		i++;
		delay_us(100);
		}
}

/**************************************************************************/
/**********************  ****************************/

void Keyboard () //  
{
	if (input(PIN_B3)== 1) //  3    5
		{
		menu_number = 0x05;
		PC_config();
		delay_ms(200);
		COM_ON;//   
		Beep();
		} 
	if (input(PIN_B4)== 1) //  3    4 VTG
		{
		menu_number = 0x04;
		COM_OFF;//   
		VTG_config();
		Beep();
		} 
	if (input(PIN_B5)== 1) //  3    3 ZDA
		{
		menu_number = 0x03;
		COM_OFF;//   
		ZDA_config();
		Beep();
		} 
	if (input(PIN_B6)== 1) //  2    1 GLL
		{
		menu_number = 0x02;
		COM_OFF;//   
		GGA_config();
		Beep();
		}
	if (input(PIN_B7)== 1) //  1    2 GSA
		{
		menu_number = 0x01;
		COM_OFF;//   
		GLL_config();
		Beep();
		}
	if (input(PIN_C5)== 1) //       
		{
			if (input (PIN_C0)==0)
				{
				output_bit (PIN_A2,1);
				delay_ms(200);
				}
			if (input (PIN_C0)==1)
				{
				output_bit (PIN_A2,0);
				delay_ms(200);
				}
			Beep();
		}

}

void Light() //      
{
	if (input (PIN_A2) == 1)
		{
		output_bit (PIN_C0,1);
		}
	if (input (PIN_A2) == 0)
		{
		output_bit (PIN_C0,0);
		}
}

void ADC_read () //   
{
	adc_value = read_adc(); //      adc_value
	ADCON0 |= 4;			//  - 
}

/************************************************************************************************/
/************************   ********************************/

void Voltage_control () //     
{
	ADC_read();
	if (adc_value <= 0x8D) //     6.0   
		{
		ClearLCD();
		GoToSymbol (0x00);
		Showstr (lowvolt); //      
		Showstr (lowvolt2);
		restart_wdt();
		Voltage_displ();
		GoToSymbol(0x54);
		Showchar(' ');
		Showstr(volts);
		GoToSymbol(0x60);
		Showchar(' ');
		Showchar(volt);
		Showchar('.');
		Showchar(volt_1);
		Showchar(volt_2);
		Showchar(volt_3);
		Showchar('B');
		Beep();				//     
		Beep();
		delay_ms(1000); 
		restart_wdt();
		}
	if (adc_value >= 0xD1) //    8.9    2
		{
		ClearLCD();
		GoToSymbol (0x00);
		Showstr (highvolt); //      
		restart_wdt();
		Voltage_displ();
		GoToSymbol(0x54);
		Showchar(' ');
		Showstr(volts);
		GoToSymbol(0x60);
		Showchar(' ');
		Showchar(volt);
		Showchar('.');
		Showchar(volt_1);
		Showchar(volt_2);
		Showchar(volt_3);
		Showchar('B');
		delay_ms(1000); 
		restart_wdt();
		}
}	


/*************************************************************************************************/
/********************************   GLL*******************************************/

void Menu_1() //   1 
	{
	gets(buf); //   USART
 	s1=buf[1]; //  
 	s4=buf[4]; //  
 	s5=buf[5]; // 
 	s6=buf[6]; //

	if (s1 == '$') //        
	 {
		   if (s4 == 'G') //    
			{
		     if (s5 == 'L') //   .
			  {
			   if (s6 == 'L') //       
				{
	 			GoToSymbol (0x00);
				Showchar (' ');
	 			Showchar (' ');
				Showchar (' ');
				Showchar ('-');
				Showchar (' ');
				Showchar ('H');
				Showchar ('a');
				Showchar (0xB3);// 
				Showchar (0xB8);// 
				Showchar (0xB4);// 
				Showchar ('a');
				Showchar (0xE5);// 
				Showchar (0xB8);// 
				Showchar (0xC7);// 
				Showchar (' ');
				Showchar ('-');
				Showchar (' ');
				Showchar (' ');
				Showchar (' ');
				showchar (' ');
    			GoToSymbol (0x40);
				Showchar (' ');
				Showchar (0xAC);// 
				Showchar (0xB8);// 
				Showchar ('p');
				Showchar ('o');
				Showchar (0xBF);//
				Showchar ('a');
				Showchar (':');
				Showchar (' ');
				Showchar (buf[8]);
				Showchar (buf[9]);
				Showchar (0xDF);//  
				Showchar (buf[10]);
				Showchar (buf[11]);
				Showchar (''');
				Showchar (buf[13]);
				Showchar (buf[14]);
				Showchar ('"');
				Showchar ('.');
				Showchar (buf[18]);
				GoToSymbol (0x14);
				Showchar (0xE0);// 
				Showchar ('o');
				Showchar (0xBB);// 
				Showchar (0xB4);// 
				Showchar ('o');
				Showchar (0xBF);// 
				Showchar ('a');
				Showchar (':');
				Showchar (buf[20]);
				Showchar (buf[21]);
				Showchar (buf[22]);
				Showchar (0xDF); //  
				Showchar (buf[23]);
				Showchar (buf[24]);
				Showchar (''');
				Showchar (buf[26]);
				Showchar (buf[27]);
				Showchar ('"');
				Showchar ('.');
				Showchar (buf[31]);
				GoToSymbol (0x54);
				Showchar (' ');
				Showchar (' ');
				Showchar ('B');
				Showchar ('p');
				Showchar ('e');
				Showchar (0xBC);// 
				Showchar (0xC7);// 
				Showchar (':');
				Showchar (' ');
				Showchar (buf[33]);
				Showchar (buf[34]);
				Showchar (':');
				Showchar (buf[35]);
				Showchar (buf[36]);
				Showchar (':');
				Showchar (buf[37]);
				Showchar (buf[38]);
				Showchar ('.');
					if (buf[43] == 0x56)
						{
						Showchar ('I');
						Showchar ('P');
						}
					if (buf[43] == 0x41)
						{
						Showchar ('V');
						Showchar ('P');
						}
				}
				else  //       USART   
				{
				Config_message();
				}
			
		}
		else					//     
			{					//    ,
			Config_message();
			}
		}
		else
			{
			Config_message();
			}
		}
		else
			{
			Config_message();
			}
restart_wdt(); //      
}

/************************************************************************************************/
/***************************   GGA***********************************************/

void Menu_2()
	{
	gets(buf); //   USART
 	s1=buf[1]; //  
 	s4=buf[4]; //  
 	s5=buf[5]; // 
 	s6=buf[6]; //

	if (s1 == '$') //        
	 {
		   if (s4 == 'G') //    
			{
		     if (s5 == 'G') //   .
			  {
			   if (s6 == 'A') //       
				{
				GoToSymbol (0x00);
				Showchar ('T');
				Showchar (':');
				Showchar (buf[8]);
				Showchar (buf[9]);
				Showchar (':');
				Showchar (buf[10]);
				Showchar (buf[11]);
				Showchar (':');
				Showchar (buf[12]);
				Showchar (buf[13]);
				Showchar (' ');
				GoToSymbol (0x40);
				Showchar ('L');
				Showchar ('A');
				Showchar ('T');
				Showchar (':');
				Showchar (' ');
				Showchar (buf[18]);
				Showchar (buf[19]);
				Showchar (0xDF); // 
				Showchar (buf[20]);
				Showchar (buf[21]);
				Showchar (''');
				Showchar (buf[23]);
				Showchar (buf[24]);
				Showchar ('"');
				Showchar (buf[28]);
				Showchar (' ');// 
				Showchar ('M');
				Showchar ('O');
				Showchar ('D');
				Showchar ('E');
				GoToSymbol (0x14);
				Showchar ('L');
				Showchar ('O');
				Showchar ('N');
				Showchar (':');
				Showchar (buf[30]);
				Showchar (buf[31]);
				Showchar (buf[32]);
				Showchar (0xDF); // 
				Showchar (buf[33]);
				Showchar (buf[34]);
				Showchar (''');
				Showchar (buf[36]);
				Showchar (buf[37]);
				Showchar ('"');
				Showchar (buf[41]);
				Showchar (' '); // 
				restart_wdt();
					if (buf[43] == '0')
						{
						Showchar ('I');
						Showchar ('N');
						Showchar ('V');
						Showchar ('L');
						}
					if (buf[43] == '1')
						{
						Showchar ('G');
						Showchar ('P');
						Showchar ('S');
						Showchar ('*');
						}
					if (buf[43] == '2')
						{
						Showchar ('G');
						Showchar ('P');
						Showchar ('S');
						Showchar ('+');
						}
				GoToSymbol (0x0B);
				Showchar ('N');
				Showchar ('S');
				Showchar ('a');
				Showchar ('t');
				Showchar ('s');
				Showchar (':');
				Showchar (buf[45]);
				Showchar (buf[46]);
				Showchar ('*');
				GoToSymbol (0x54);
				Showchar ('H');
				Showchar ('A');
				Showchar ('S');
				Showchar (':');

					if  (buf[43] == '0')
						{
						Showchar ('-');
						Showchar ('-');
						Showchar ('-');
						Showchar ('-');
						Showchar ('-');
						Showchar ('.');
						Showchar ('-');
						Showchar (' ');
						Showchar ('G');
						Showchar ('H');
						Showchar ('-');
						Showchar ('-');
						Showchar ('-');
						Showchar ('-');
						Showchar ('.');
						Showchar ('-');
						}
					else
						{
						Showchar (buf[53]);
						Showchar (buf[54]);
						Showchar (buf[55]);
						Showchar (buf[56]);
						Showchar (buf[57]);
						Showchar ('.');
						Showchar (buf[59]);
						Showchar (' ');
						Showchar ('G');
						Showchar ('H');
						Showchar (buf[63]);
						Showchar (buf[64]);
						Showchar (buf[65]);
						Showchar (buf[66]);
						Showchar ('.');
						Showchar (buf[68]);	
						}
				}
				else  //       USART   
				{
				GoToSymbol (0x00);
				Showstr (str3);
				GoToSymbol(0x40);
				Showstr (str4);
				}
			
		}
		else					//     
			{			       //    ,
			Config_message();
			}
		}
		else
			{
			Config_message();
			}
		}
		else
			{
			Config_message();
			}
restart_wdt(); //      
}

/*********************************************************************************/
/*******************   ZDA****************************************/


void Menu_3()
	{
	gets(buf); //   USART
 	s1=buf[1]; //  
 	s4=buf[4]; //  
 	s5=buf[5]; // 
 	s6=buf[6]; //

	if (s1 == '$') //        
	 {
		   if (s4 == 'Z') //    
			{
		     if (s5 == 'D') //   .
			  {
			   if (s6 == 'A') //       
				{
				GoToSymbol (0x00);
				Showchar(' ');
				Showchar(' ');
				Showchar('-');
				Showchar(' ');
				Showchar('B');
				Showchar('p');
				Showchar('e');
				Showchar(0xbc);//
				Showchar(0xc7);//
				Showchar(' ');
				Showchar(0xb8);//
				Showchar(' ');
				Showchar(0xe3);//
				Showchar('a');
				Showchar(0xbf);//
				Showchar('a');
				Showchar(' ');
				Showchar('-');
				Showchar(' ');
				Showchar(' ');
				GoToSymbol(0x14);
				Showchar('B');
				Showchar('p');
				Showchar('e');
				Showchar(0xbc);//
				Showchar(0xc7);//
				Showchar(' ');
				Showchar('U');
				Showchar('T');
				Showchar('C');
				Showchar(':');
				Showchar(' ');
				Showchar(buf[8]);
				Showchar(buf[9]);
				Showchar(':');
				Showchar(buf[10]);
				Showchar(buf[11]);
				Showchar(':');
				Showchar(buf[12]);
				Showchar(buf[13]);
				Showchar(' ');
				GoToSymbol(0x40);
				Showchar(' ');
				Showchar(' ');
				Showchar(0xe0);//
				Showchar('a');
				Showchar(0xbf);//
				Showchar('a');
				Showchar(' ');
				Showchar(' ');
				Showchar(' ');
				Showchar(':');
				Showchar(' ');
				Showchar(buf[18]);
				Showchar(buf[19]);
				Showchar('.');
				Showchar(buf[21]);
				Showchar(buf[22]);
				Showchar('.');
				Showchar(buf[26]);
				Showchar(buf[27]);
				Showchar(' ');
//				Showchar(adc_value);
//				putc(adc_value);

				/****************   *****************/

				Voltage_displ();//  o 
				restart_wdt();
//				putc(adc_value); //   USART    
				GoToSymbol (0x54);
				Showstr (volts);//  :
				Showchar (' ');
				GoToSymbol(0x5f);
				Showchar(' ');
				Showchar (' ');
				Showchar (volt);//  
				Showchar ('.');
				Showchar (volt_1);//   
				Showchar (volt_2);//   
				Showchar (volt_3);//   
				Showchar ('B');
				Showchar (' ');
				restart_wdt();
				}
				else  //       USART   
				{
				Config_message();
				}
			
			}
			else			    //     
			{					//    ,
			 Config_message();
			}
		 }
	   	 else
		 {
		 Config_message();
		 }
	 }
	 else
	 {
	 Config_message();
	 }
restart_wdt(); //      
}
	
/*************************************************************************************************/
/**********************************   VTG*****************************************/

void Menu_4()
{
	gets(buf); //   USART
 	s1=buf[1]; //  
 	s4=buf[4]; //  
 	s5=buf[5]; // 
 	s6=buf[6]; //

	if (s1 == '$') //        
	 {
		   if (s4 == 'V') //    
			{
		     if (s5 == 'T') //   .
			  {
			   if (s6 == 'G') //       
				{
				GoToSymbol(0x00);
				Showchar(' ');
				Showchar('-');
				Showchar(' ');
				Showchar('K');
				Showchar('y');
				Showchar('p');
				Showchar('c');
				Showchar(' ');
				Showchar(0xb8);//
				Showchar(' ');
				Showchar('c');
				Showchar(0xba);//k
				Showchar('o');//o
				Showchar('p');
				Showchar('o');
				Showchar('c');
				Showchar(0xbf);//
				Showchar(0xc4);
				Showchar(' ');
				Showchar('-');
				GoToSymbol(0x40);
				if (buf[8] != ',')
					{
					if (buf[41] != 'N')
						{
						Showchar(buf[8]);
						Showchar(buf[9]);
						Showchar(buf[10]);
						Showchar('.');
						Showchar(buf[12]);
						Showchar(0xb8);//
						Showchar('c');
						Showchar(0xbf);//
						Showchar('.');
						Showchar(' ');
						Showchar(' ');
						Showchar(buf[16]);
						Showchar(buf[17]);
						Showchar(buf[18]);
						Showchar('.');
						Showchar(buf[20]);
						Showchar(0xbc);//
						Showchar('a');
						Showchar(0xb4);//
						Showchar('.');
						GoToSymbol(0x14);// 
						Showchar(buf[24]);
						Showchar(buf[25]);
						Showchar(buf[26]);
						Showchar('.');
						Showchar(buf[28]);
						Showchar('y');
						Showchar(0xb7);//
						Showchar(0xbb);//
						Showchar('.');
						Showchar(' ');
						Showchar(buf[32]);
						Showchar(buf[33]);
						Showchar(buf[34]);
						Showchar(buf[35]);
						Showchar('.');
						Showchar(buf[37]);
						Showchar(0xba);//
						Showchar(0xbc);//
						Showchar('/');
						Showchar(0xc0);//
						}
						else  //     
						{
						Showchar('-');
						Showchar('-');
						Showchar('-');
						Showchar('.');
						Showchar('-');
						Showchar(0xb8);//
						Showchar('c');
						Showchar(0xbf);//
						Showchar('.');
						Showchar(' ');
						Showchar(' ');
						Showchar('-');
						Showchar('-');
						Showchar('-');
						Showchar('.');
						Showchar('-');
						Showchar(0xbc);//
						Showchar('a');
						Showchar(0xb4);//
						Showchar('.');
						GoToSymbol(0x14);// 
						Showchar('-');
						Showchar('-');
						Showchar('-');
						Showchar('.');
						Showchar('-');
						Showchar('y');
						Showchar(0xb7);//
						Showchar(0xbb);//
						Showchar('.');
						Showchar(' ');
						Showchar('-');
						Showchar('-');
						Showchar('-');
						Showchar('-');
						Showchar('.');
						Showchar('-');
						Showchar(0xba);//
						Showchar(0xbc);//
						Showchar('/');
						Showchar(0xc0);//
						}
					}
					else  //     
					{
					Showchar('-');
					Showchar('-');
					Showchar('-');
					Showchar('.');
					Showchar('-');
					Showchar(0xb8);//
					Showchar('c');
					Showchar(0xbf);//
					Showchar('.');
					Showchar(' ');
					Showchar(' ');
					Showchar('-');
					Showchar('-');
					Showchar('-');
					Showchar('.');
					Showchar('-');
					Showchar(0xbc);//
					Showchar('a');
					Showchar(0xb4);//
					Showchar('.');
					GoToSymbol(0x14);// 
					Showchar('-');
					Showchar('-');
					Showchar('-');
					Showchar('.');
					Showchar('-');
					Showchar('y');
					Showchar(0xb7);//
					Showchar(0xbb);//
					Showchar('.');
					Showchar(' ');
					Showchar('-');
					Showchar('-');
					Showchar('-');
					Showchar('-');
					Showchar('.');
					Showchar('-');
					Showchar(0xba);//
					Showchar(0xbc);//
					Showchar('/');
					Showchar(0xc0);//
					}
				Voltage_displ();//   
				GoToSymbol(0x54);
				Showchar('H');
				Showchar('a');
				Showchar(0xbe);//
				Showchar('p');
				Showchar('.');
				Showchar(0xb2);
				Showchar('a');
				Showchar(0xbf);//
				Showchar(':');
				Showchar(' ');
				Showchar(volt);
				Showchar('.');
				Showchar(volt_1);
				Showchar(volt_2);
				Showchar(volt_3);
				Showchar('B');
				GoToSymbol (0x65);
				if (buf[41] = 'N')
				{
				Showchar('I');
				Showchar('N');
				Showchar('V');
				}
				else
				{
				Showchar('G');
				Showchar('P');
				Showchar('S');
				}			
				}
				else  //       USART   
				{
				Config_message();
				}
			
			}
			else			    //     
			{					//    ,
			Config_message();
			}
		 }
	   	 else
		 {
		 Config_message();
		 }
	 }
	 else
	 {
	 Config_message();
	 }
restart_wdt(); //      
}

//**********************************************************************************************/
/************************   5  *******************************************/

void Menu_5()
{
	Showstr (emptystr);
	GoToSymbol(0x40);
	Showchar(' ');
	Showchar('*');
	Showchar('C');
	Showchar('o');
	Showchar('e');
	Showchar(0xe3);//
	Showchar(0xb8);//
	Showchar(0xbd);//
	Showchar('e');
	Showchar(0xbd);//
	Showchar(0xb8);//
	Showchar('e');
	Showchar(' ');
	Showchar('c');
	Showchar(' ');
	Showchar(0xaf);
	Showchar('B');
	Showchar('M');
	Showchar('*');
	Showchar(' ');
	GoToSymbol(0x14);
	Showstr(emptystr);
	Voltage_displ();//   
	GoToSymbol(0x54);
	Showchar(' ');
	Showchar(' ');
	Showchar('H');
	Showchar('a');
	Showchar(0xbe);//
	Showchar('p');
	Showchar('.');
	Showchar(0xb2);
	Showchar('a');
	Showchar(0xbf);//
	Showchar(':');
	Showchar(' ');
	Showchar(volt);
	Showchar('.');
	Showchar(volt_1);
	Showchar(volt_2);
	Showchar(volt_3);
	Showchar('B');
	Showchar(' ');
	Showchar(' ');
	delay_ms(1000);
	restart_wdt();
}
		
/***********************  **************************************/

void main()
{    
	 setup_WDT(WDT_2304MS); //        USART
	 setup_adc_ports (RA0_ANALOG); //   RA0
	 setup_adc(ADC_CLOCK_DIV_32);  //    Fosc/32
	 set_adc_channel (0);
	 set_tris_D (0xFF); //
 	 set_tris_B (0xFF); //
 	 set_tris_A (0x03); // /
	 output_bit (PIN_A2,0);
  	 InitLCD(); // 
 	 WriteByteCommand (0x00); // 

while (1)
{
if (menu_number != 0x01)
	{
	if (menu_number != 0x02)
		{
		if (menu_number != 0x03)
			{
			if (menu_number != 0x04)
				{
				if (menu_number != 0x05)
					{	
					GoToSymbol (0x00);
					Showstr(start);//     
					GoToSymbol (0x40);
					Showchar(' ');
					Showchar('1');
					Showchar('-');
					Showchar('G');
					Showchar('L');
					Showchar('L');
					Showchar(' ');
					Showchar('2');
					Showchar('-');
					Showchar('G');
					Showchar('G');
					Showchar('A');
					Showchar(' ');
					Showchar('3');
					Showchar('-');
					Showchar('Z');
					Showchar('D');
					Showchar('A');
					Showchar(' ');
					Showchar(' ');
					GoToSymbol(0x14);
					Showchar(' ');
					Showchar(' ');
					Showchar(' ');
					Showchar(' ');
					Showchar('4');	
					Showchar('-');
					Showchar('V');
					Showchar('T');
					Showchar('G');
					Showchar(' ');
					Showchar('5');
					Showchar('-');
					Showchar('C');
					Showchar('O');
					Showchar('M');
					GoToSymbol(0x54);
					Showchar('*');
					GoToSymbol(0x58);
					Showchar('R');
					Showchar('A');
					Showchar('3');
					Showchar('P');
					Showchar('C');
					Showchar('S');
					Showchar(0x60);
					Showchar('2');
					Showchar('0');
					Showchar('0');
					Showchar('8');
					GoToSymbol(0x67);	
					Showchar('*');				
					Keyboard();
					restart_wdt();
					Light();
					delay_ms(800);
					}					
				}
			}
		}
	}


if (menu_number == 0x01)  //  001   1
	{
	Voltage_control();
	Keyboard();
	COM_OFF;//   
	Light();
	Menu_1();
	}

if (menu_number == 0x02)  //  002   2
	{
	Voltage_control();
	Keyboard();
	COM_OFF;//   
	Light();
	Menu_2();
	}

if (menu_number == 0x03) //  003   3
	{
	Voltage_control();
	Keyboard();
	COM_OFF;//   
	Light();
	Menu_3();
	}

if (menu_number == 0x04) //  004   4
	{
	Voltage_control();
	Keyboard();
	COM_OFF;//   
	Light();
	Menu_4();

	}

if (menu_number == 0x05) //  005   5
	{
	Voltage_control();
	COM_ON;//   
	Keyboard();
	Light();
	Menu_5();
	}

}
}

